Redmine - Defect #37473

Focus Issueld not working when linking issues
2022-07-20 11:18 - Alexandre Guilleme

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 428

Resolution: Fixed Affected version: 4.2.7
Description

When | click on the add link in the linked issues section of an issue, the kind Combo and the IssueNumber edit are displayed. Before
(can't remember if 5.0.0 or 4.X), the Edit received focus, so that | could just type in issue number directly after clicking Add. Now, |
must manually clic in the Edit before typing.

(the captions may be wrong as | am in french translation)

Associated revisions

Revision 21867 - 2022-09-28 11:18 - Go MAEDA

Issue ID field does not get focus when adding a related issue (#37473).

Patch by Mizuki ISHIKAWA.

Revision 21868 - 2022-09-28 11:20 - Go MAEDA
Merged r21867 from trunk to 5.0-stable (#37473).

Revision 21869 - 2022-09-28 11:21 - Go MAEDA
Merged r21867 from trunk to 4.2-stable (#37473).

History

#1 - 2022-07-20 11:39 - Go MAEDA
- Status changed from New to Confirmed

- Affected version changed from 5.0.2 to 4.2.7
Alexandre Guilleme wrote:
Before (can't remember if 5.0.0 or 4.X), the Edit received focus, so that | could just type in issue number directly after clicking Add. Now, | must

manually clic in the Edit before typing.

| have confirmed the issue. Redmine 4.1.7 works as described but Redmine 4.2.7 and 5.0.2 don't.

#2 - 2022-07-26 02:50 - Mizuki ISHIKAWA

I think this is a jQuery 3.6.0 specific issue and is related to the following two issues.

® You cannot programmatically focus an element after you have attempted to focus it while it was hidden (display:none)
https://github.com/jquery/jquery/issues/4950

® You cannot programmatically focus an element after removing its focus handler https:/github.com/jquery/jquery/issues/4867

o => The milestone for this issue is 3.6.1, so it will likely be resolved after 3.6.1 is released!

Even with jQuery 3.6.0, the problem does not seem to occur if the code is changed to focus only when the focus target is :visible, as in the following
diff.

diff --git a/app/helpers/application_helper.rb b/app/helpers/application_helper.rb
index e2eebfad4l2..95975cdd78 100644

-—— a/app/helpers/application_helper.rb

+++ b/app/helpers/application_helper.rb

@@ -335,7 +335,7 @@ module ApplicationHelper

def toggle_link (name, id, options={})
onclick = +"S$('##{id}') .toggle(); "

- onclick << (options[:focus] ? "$('##{options[:focus]}').focus(); " : "this.blur(); ")
+ onclick << (options[:focus] ? "$('##{options[:focus]}:visible').focus(); " : "this.blur(); ")
onclick << "$(window) .scrollTop ($('##{options[:focus]}') .position().top); " if options[:scroll]

onclick << "return false;"
link_to(name, "#", :onclick => onclick)
diff --git a/public/javascripts/application.js b/public/javascripts/application.js
index 91dal92290..4d039cdel2 100644
-—- a/public/javascripts/application. js
+++ b/public/javascripts/application. js
@@ -958,7 +958,7 @@ function addFormObserversForDoubleSubmit () {

function defaultFocus () {

if (($('"#content :focus').length == 0) && (window.location.hash == '')) {
N S ('"#content input[type=text], #content textarea').first().focus();
+ S ('#content input[type=text]:visible, #content textarea:visible').first().focus();

#3 - 2022-07-26 11:53 - Go MAEDA

- Target version set to Candidate for next minor release

#4 - 2022-07-28 23:40 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.2.8

Setting the target version to 4.2.8.

#5 - 2022-09-27 22:16 - Marius BALTEANU

We updated jQuery to 3.6.1 on all stable versions and the fix proposed by Mizuki works in my environment. Is is something else that blocks us to
commit the fix? | would like to include it in the new versions.

#6 - 2022-09-27 22:46 - Marius BALTEANU

- Subject changed from Focus Issueld when linking issues to Focus Issueld not working when linking issues

#7 - 2022-09-28 11:31 - Go MAEDA
- Status changed from Confirmed to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you all for reporting and fixing the issue.
Marius BALTEANU wrote:

Is is something else that blocks us to commit the fix? | would like to include it in the new versions.

Sorry, | overlooked this issue.

#8 - 2022-09-28 23:07 - Marius BALTEANU
Go MAEDA wrote:

Committed the patch. Thank you all for reporting and fixing the issue.
Marius BALTEANU wrote:

Is is something else that blocks us to commit the fix? | would like to include it in the new versions.

Sorry, | overlooked this issue.

Thanks! Don't worry, | just wanted to double check that are not other issues with the patch.
